/* Copyright (c) 2006-2018 Peter Speck / Vitality. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Vitality nor the names of its contributors may be
 *       used to endorse or promote products derived from this software without
 *       specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PETER SPECK / VITALITY AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL PETER SPECK / VITALITY AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.jabhts.junit.tests.eAttributeCollections;

import org.jabhts.annotation.attribute.collection.ACollection;
import org.jabhts.annotation.attribute.collection.ASrcWidthHeight;
import org.jabhts.annotation.attribute.content.AClassPost;
import org.jabhts.annotation.attribute.content.AStylePost;
import org.jabhts.annotation.global.TCompile;
import org.jabhts.junit.lib.TestBase;

@TCompile
public class TestAttributeCollections extends TestBase
{
	@ASrcWidthHeight
	String image1 = "src='j1' width=10 height=12";


	@ASrcWidthHeight
	String image2 = "src='j1' width=20 height=22";


	@ASrcWidthHeight
	String image3 = "src='j3' width=30 height=32";

	@ASrcWidthHeight
	String image4 = "src='j4' width=40 height=42";

	@ACollection(attributes = {"style", "class", "title"})
	String multiMulti = "style='border: 1px solid green;' class=RealClass title='Comment here'";


	protected void emitTemplate() throws Exception
	{
		new TestAttributeCollectionsTp(this).emit(pw);
	}

	@AClassPost
	String header = "DynamicClass ExtraClass";

	@AStylePost
	String addedStyles = "color: green; font: 12px Courier";
}
