/* Copyright (c) 2006-2018 Peter Speck / Vitality. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Vitality nor the names of its contributors may be
 *       used to endorse or promote products derived from this software without
 *       specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PETER SPECK / VITALITY AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL PETER SPECK / VITALITY AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.jabhts.junit.tests.gStyles;

import org.jabhts.annotation.attribute.sub.SCollection;
import org.jabhts.annotation.attribute.sub.SDisplay;
import org.jabhts.annotation.attribute.sub.SDisplayBlock;
import org.jabhts.annotation.attribute.sub.SDisplayInline;
import org.jabhts.annotation.attribute.sub.SValue;
import org.jabhts.annotation.element.EText;
import org.jabhts.annotation.global.TCompile;
import org.jabhts.junit.lib.TestBase;

@TCompile
public class TestStyles extends TestBase
{
	@EText
	String getTextOne()
	{
		return "Making a styled test";
	}

	@SDisplayBlock
	boolean textOne = true;

	@SDisplayBlock
	boolean displayBlockOne()
	{
		return false;
	}

	@SDisplay
	static boolean hideBlockTwo()
	{
		return false;
	}

	@SDisplay
	boolean showString1()
	{
		return true;
	}

	boolean odd = false;

	@SValue(styles = "color")
	String colorString2()
	{
		odd ^= true;
		return odd ? "yellow" : "cyan";
	}

	@SDisplayInline
	static boolean seeMe1 = true;

	@SDisplayInline
	boolean invisible1 = false;

	@SDisplayInline
	boolean seeMe2 = true;

	@SDisplayInline
	static final boolean invisible2 = false;

	@SCollection(styles = {"color", "margin-top", "margin-bottom"})
	String multiStyles = "color: red; margin-top: 10px; margin-bottom: 5px";


	protected void emitTemplate() throws Exception
	{
		new TestStylesTp(this).emit(pw);
	}
}
