/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>
#import <Security/Authorization.h>
#import "XmlDoc.h"

@class AlertHelper;
@class PrefsHelper;
@class SFAuthorizationView;

// Upgrading of prefs is performed from java!!!

@interface Prefs : XmlDoc {
}

+ (Prefs*)prefsWithAlertHelper:(AlertHelper*)alertHelper
	   withSFAuthorizationView:(SFAuthorizationView*)authView;
- (void)forcedReload;

//-------------------------------------------------------------- Globals

- (AlertHelper*)alertHelper;

//-------------------------------------------------------------- Filters

- (NSXMLElement*)filtersE;

- (NSXMLElement*)rulePreviewE;
- (BOOL)zapRulePreviewElement;

//-------------------------------------------------------------- Save
- (BOOL)save;
- (void)saveIfDirty:(id)sender;
- (void)markAsDirty;

//-------------------------------------------------------------- Auth

- (AuthorizationRef)authRef;
- (BOOL)hasGlimmerAuth;
//- (NSData*)authExternalForm; // null if no auth.

- (void)notifyUpdatedAuthorizationState;

- (int)runAuthHelperWithArgs:(NSArray*)args
			   withInputData:(NSArray*)inputData // array of NSData
					withAuth:(BOOL)withAuth;

- (int)runAuthHelperWithArgs:(NSArray*)args
			   withInputData:(NSArray*)inputData // array of NSData
			  withOutputData:(NSMutableData*)outputData
					withAuth:(BOOL)withAuth;

@end
