/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>

typedef NS_ENUM(NSInteger, RuleType) {
	BlockRuleType, WhitelistRuleType, ModifyContentRuleType, ModifyErrorStatusRuleType,
	RequestRuleType, KeywordRuleType, UnknownRuleType
} ;


@interface Rule : NSObject {

}

+ (RuleType)getRuleType:(NSXMLElement*)ruleE;
+ (BOOL)ruleIsSafe:(NSXMLElement*)ruleE;

@end

static inline NSString* soft(NSString* s)
{
	return s ? s : @"";
}
