/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>
#import "CodeEditHelper.h"

@class Prefs;
@class AlertHelper;
@class ServerCommunication;
@class ClickActionTextField;
@class NamedEnum;
@class ProxyScriptEditor;

@protocol ProxyScriptEditorDelegate

- (void)notifyProxyScriptEditorCommitted:(ProxyScriptEditor*)editor;

@end

@interface ProxyScriptEditor : NSObject<CodeEditDelegate,NSTabViewDelegate,NSTextViewDelegate,NSTextStorageDelegate>
{
}

+ (void)initProxyScriptEditor;

- (instancetype)initWithServerCommunication:(ServerCommunication*)comm
					   withBundle:(NSBundle*)bundle
					 withDelegate:(id<ProxyScriptEditorDelegate>)delegate;
- (void)dealloc;

- (IBAction)cancelAction:(id)sender;
- (IBAction)commitAction:(id)sender;

- (IBAction)scriptHelpAction:(id)sender;

@end

extern NamedEnum* proxyTypeEnum;
typedef NS_ENUM(NSInteger, ProxyType) {
	NoProxy, JavascriptProxy, StaticProxy
} ;
