/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>

@protocol CodeEditDelegate

- (BOOL)isJavascriptTextStorage:(NSTextStorage*)storage;

@end

//========================================================================

@interface CodeEditHelper : NSObject {
}

- (instancetype)initWithDelegate:(id<CodeEditDelegate>)delegate;


- (void)syntaxHighlight:(NSMutableAttributedString*)attributedString
		   isJavascript:(BOOL)js;

- (void)syntaxHighlightJavascript:(NSTextStorage*)textStorage;
- (void)delayedSyntaxHighlightJavascript:(NSTextStorage*)textStorage;

- (void)setCodeTabs:(NSTextStorage*)storage;

- (void)setCodeTextView:(NSTextView*)textView
			   withText:(NSString*)txt;

- (void)textStorageDidProcessEditing:(NSNotification *)noti;

// returns NULL if results in empty string.
- (NSString*)trimmedTextViewString:(NSTextView*)textView;

// returns NULL if results in empty string.
+ (NSString*)trimmedString:(NSString*)src;

@end
