/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.admin.misc;

import org.glimmerblocker.proxy.admin.AbstractAdminHandler;
import org.glimmerblocker.proxy.http.data.HeadersBuilder;
import org.glimmerblocker.proxy.http.data.ResultData;
import org.glimmerblocker.proxy.proxyRequest.ProxyRequestHandler;
import org.jetbrains.annotations.NotNull;

public class AdminHelloWorld extends AbstractAdminHandler
{
	public AdminHelloWorld(@NotNull ProxyRequestHandler req) throws Exception
	{
		super(req);
	}

	protected void main() throws Exception
	{
		HeadersBuilder hb = HeadersBuilder.makeEmpty();
		hb.contentType = "text/plain";
		hb.addNoCacheHeaders(); // no reason for Safari to cache it when it's on local disk.
		ResultData rd = new ResultData(hb.toHeaders(), "Hello, world!".getBytes("UTF-8"));
		req.sendResultData(rd);
	}
}
