/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.admin.misc;

import java.io.File;
import org.glimmerblocker.proxy.admin.AbstractAdminHandler;
import org.glimmerblocker.proxy.globals.GlimmerGlobals;
import org.glimmerblocker.proxy.http.data.HeadersBuilder;
import org.glimmerblocker.proxy.http.data.ResultData;
import org.glimmerblocker.proxy.proxyRequest.ProxyRequestHandler;
import org.jetbrains.annotations.NotNull;
import dk.vitality.lib.foundation.io.FileContentsUtils;

public class AdminLogoLarge extends AbstractAdminHandler
{
	public AdminLogoLarge(@NotNull ProxyRequestHandler req) throws Exception
	{
		super(req);
	}

	protected void main() throws Exception
	{
		File f = new File(GlimmerGlobals.prefsPanelResourcesF, "tangerine.png");
		if (!f.exists()) {
			File f2 = new File("../PrefsPane/Resources/tangerine.png");
			if (f2.exists())
				f = f2;
			else
				throw new Exception("Missing " + f.getPath());
		}
		HeadersBuilder hb = HeadersBuilder.makeEmpty();
		hb.contentType = "image/png";
		hb.addNoCacheHeaders(); // no reason for Safari to cache it when it's on local disk.
		ResultData rd = new ResultData(hb.toHeaders(), FileContentsUtils.readFile(f));
		req.sendResultData(rd);
	}
}