/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.admin.misc;

import java.util.List;
import org.glimmerblocker.proxy.admin.AbstractAdminXmlHandler;
import org.glimmerblocker.proxy.globals.suspect.Suspect;
import org.glimmerblocker.proxy.proxyRequest.ProxyRequestHandler;
import org.glimmerblocker.proxy.rule.AbstractRule;
import org.jetbrains.annotations.NotNull;

public class AdminReloadPanelSettings extends AbstractAdminXmlHandler
{
	public AdminReloadPanelSettings(@NotNull ProxyRequestHandler req) throws Exception
	{
		super(req);
	}

	protected void processAdminXml() throws Exception
	{
		globals.reloadPanelSettings();
		int filterId = urlParams.optInt("filter", 0);
		if (filterId == 0)
			return;
		int ruleId = urlParams.optInt("rule", 0);
		for (Suspect suspect : globals.suspects.getSuspects()) {
			boolean mobile = true;
			List<AbstractRule> ruleList = globals.ruleCollection.getRules(
					suspect.host, suspect.path, suspect.query, mobile);
			for (AbstractRule rule : ruleList) {
				if (rule.ruleId == ruleId && rule.filterId == filterId) {
					globals.suspects.removeSuspect(suspect);
					break;
				}
			}
		}

	}
}
