/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.util;

import org.glimmerblocker.proxy.http.data.Headers;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * Used when the upstream server fails to send content and we want to abort the request-handling and
 * send a simple "upstream failed" error to the client.
 */
public class HttpException extends Exception
{
	@NotNull public final Headers headers;

	public HttpException(@NotNull Headers headers)
	{
		super(headers.statusMessage);
		this.headers = headers;
	}

	public HttpException(@NotNull Headers headers, @Nullable Throwable throwable)
	{
		super(headers.statusMessage, throwable);
		this.headers = headers;
	}
}
